<?php
/*
Plugin Name: Top Flash Embed
Version: 0.2.2
Description: This a simple plugin for embedding flash into pages/posts through the editor.
Author: Nikos M.
Author URI: http://nikos-web-development.netai.net
Plugin URI: http://nikos-web-development.netai.net
License: GPL
*/

//define('WP_DEBUG',false);
define("TOPFLASH_URL", plugins_url('',__FILE__) );
define("TOPFLASH_DIR", rtrim(dirname(__FILE__), '/'));


//API
add_action('admin_menu','top_flash_menu');
add_action('admin_init','top_flash_admin_init',5);
add_action('admin_head','top_flash_script',5);

//functions
function top_flash_set() {
//$top_flash_options = get_option('top_flash');
?>
	<div class="wrap">
		  <h2><?php _e('Top Flash Settings'); ?></h2>
			  <div>
				<?php echo __('Your Absolute Path is:').'&nbsp;&nbsp;'.rtrim(ABSPATH,'/'); ?>
			  </div>
			  <div>
				<?php echo __('Your Root URL is:').'&nbsp;&nbsp;'.site_url(); ?>
			  </div>
			  <form method="post" action="options.php" id="top-flash-settings">
				<?php settings_fields('top_flash_options'); ?>
				  <table class="form-table">
				  <tr valign="middle">
				  <th scope="row"><?php _e('Flash Movies Directory'); ?></th>
				  <td><input type="text" name="top_flash_dir" value="<?php echo get_option('top_flash_dir'); ?>" class="field text wide"/></td>
				  </tr>
				  <tr valign="middle">
				  <th scope="row"><?php _e('Flash Base URL'); ?><br>
				  </th>
				  <td><input type="text" name="top_flash_url" value="<?php echo get_option('top_flash_url'); ?>" class="field text wide"/></td>
				  </tr>
				  </table>
			  <p class="submit">
			  <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			  </p>
			  </form>
			<div id="instructions">
			Enter the absolute path to the directory where flash files are stored and the base URL for that directory, and you are done. <br />In the editor you will see a button allowing you to embed flash files in your post/page.
			</div>
			  <div>
			  <?php echo __('Example:'); ?><br />
			  If your flash directory is named &quot;flash&quot; and resides inside &quot;wp-content&quot; directory then
			  the absolute path would be<br />
			  <strong><?php echo rtrim(ABSPATH,'/').'/wp-content/flash/'; ?></strong><br />
			  and the base url would be<br />
			  <strong><?php echo site_url().'/wp-content/flash/'; ?></strong><br />
			  </div>
	  </div>
 <?php
}//End Function

function top_flash_menu() {
	$page = add_submenu_page('options-general.php','Top Flash Embed', 'Top Flash Embed','manage_options','top_flash_set', 'top_flash_set');
	register_setting ('top_flash_options', 'top_flash_dir', '');
	register_setting ('top_flash_options', 'top_flash_url', '');
}


function top_flash_admin_init() {
	if ( current_user_can( 'edit_posts' ) && current_user_can( 'edit_pages' ) ) {
		add_filter( 'mce_buttons', 'top_flash_filter_mce_button',5 );
		add_filter( 'mce_external_plugins', 'top_flash_filter_mce_plugin',5 );
	}
}

function top_flash_filter_mce_button( $buttons ) {
	array_push( $buttons, 'separator','top_flash_button' );
	return $buttons;
}

function top_flash_filter_mce_plugin( $plugins ) {
	$plugins['top_flash'] = TOPFLASH_URL . '/top-flash.js';
	return $plugins;
}

function top_flash_script() {
	?>
	<script type="text/javascript">
	//<![CDATA[
		userSettings.top_flash_plugin_dir = '<?php echo TOPFLASH_URL; ?>/';
	//]]>
</script> 
	<?php
}

function topswf_func( $atts ) {
	extract( shortcode_atts( array(
		'swf' => '',
		'width' => '100',
		'height' => '100'
	), $atts ) );
 
	$swf=trim($swf);
	$swfoutput=<<<SWF
\n<!-- top flash embed swf tag start-->
	<object width="$width" height="$height" data="$swf" type="application/x-shockwave-flash">
		<param name="movie" value="$swf" /> 
	</object>
<!-- top flash embed swf tag end-->\n
SWF;
	if ($swf!='')
	return $swfoutput;
	return '';
}
add_shortcode( 'topswf', 'topswf_func' );
?>